7e3c37f4800d573c439a60a99245bc44450824a1
[binutils-gdb.git] / configure.in
1 #! /bin/bash
2 ##############################################################################
3
4 ## This file is a shell script fragment that supplies the information
5 ## necessary to tailor a template configure script into the configure
6 ## script appropriate for this directory. For more information, check
7 ## any existing configure script.
8
9 ## Be warned, there are two types of configure.in files. There are those
10 ## used by Autoconf, which are macros which are expanded into a configure
11 ## script by autoconf. The other sort, of which this is one, is executed
12 ## by Cygnus configure.
13
14 ## For more information on these two systems, check out the documentation
15 ## for 'Autoconf' (autoconf.texi) and 'Configure' (configure.texi).
16
17 # Copyright (C) 1992, 1993, 1994, 1995, 1996, 1997, 1998,
18 # 1999, 2000, 2001, 2002 Free Software Foundation, Inc.
19 #
20 # This file is free software; you can redistribute it and/or modify it
21 # under the terms of the GNU General Public License as published by
22 # the Free Software Foundation; either version 2 of the License, or
23 # (at your option) any later version.
24 #
25 # This program is distributed in the hope that it will be useful, but
26 # WITHOUT ANY WARRANTY; without even the implied warranty of
27 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
28 # General Public License for more details.
29 #
30 # You should have received a copy of the GNU General Public License
31 # along with this program; if not, write to the Free Software
32 # Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
33
34 ##############################################################################
35
36 ### To add a new directory to the tree, first choose whether it is a target
37 ### or a host dependent tool. Then put it into the appropriate list
38 ### (library or tools, host or target), doing a dependency sort. For
39 ### example, gdb requires that byacc (or bison) be built first, so it is in
40 ### the ${host_tools} list after byacc and bison.
41
42
43 # these libraries are used by various programs built for the host environment
44 #
45 host_libs="intl mmalloc libiberty opcodes bfd readline db tcl tk tcl8.1 tk8.1 tclX itcl tix libgui zlib"
46
47 libstdcxx_version="target-libstdc++-v3"
48 # Don't use libstdc++-v3's flags to configure/build itself.
49 libstdcxx_flags='`case $$dir in libstdc++-v3 | libjava) ;; *) test ! -f $$r/$(TARGET_SUBDIR)/libstdc++-v3/testsuite_flags || $(SHELL) $$r/$(TARGET_SUBDIR)/libstdc++-v3/testsuite_flags --build-includes;; esac` -L$$r/$(TARGET_SUBDIR)/libstdc++-v3/src -L$$r/$(TARGET_SUBDIR)/libstdc++-v3/src/.libs'
50
51 # these tools are built for the host environment
52 # Note, the powerpc-eabi build depends on sim occurring before gdb in order to
53 # know that we are building the simulator.
54 host_tools="texinfo byacc flex bison binutils ld gas gcc cgen sid sim gdb make patch prms send-pr gprof gdbtest tgas etc expect dejagnu ash bash bzip2 m4 autoconf automake libtool ispell grep diff rcs cvssrc fileutils shellutils time textutils wdiff find emacs emacs19 uudecode hello tar gzip indent recode release sed utils guile perl apache inet gawk findutils snavigator libtool gettext zip fastjar"
55
56 # libgcj represents the runtime libraries only used by gcj.
57 libgcj="target-libffi \
58 target-boehm-gc \
59 target-zlib \
60 target-qthreads \
61 target-libjava"
62
63 # these libraries are built for the target environment, and are built after
64 # the host libraries and the host tools (which may be a cross compiler)
65 #
66 target_libs="target-libiberty \
67 target-libgloss \
68 target-newlib \
69 target-librx \
70 ${libstdcxx_version} \
71 target-libf2c \
72 ${libgcj}
73 target-libobjc"
74
75 # these tools are built using the target libs, and are intended to run only
76 # in the target environment
77 #
78 # note: any program that *uses* libraries that are in the "target_libs"
79 # list belongs in this list. those programs are also very likely
80 # candidates for the "native_only" list which follows
81 #
82 target_tools="target-examples target-groff target-gperf"
83
84 ################################################################################
85
86 ## These two lists are of directories that are to be removed from the
87 ## ${configdirs} list for either cross-compilations or for native-
88 ## compilations. For example, it doesn't make that much sense to
89 ## cross-compile Emacs, nor is it terribly useful to compile target-libiberty in
90 ## a native environment.
91
92 # directories to be built in the native environment only
93 #
94 # This must be a single line because of the way it is searched by grep in
95 # the code below.
96 native_only="autoconf automake libtool cvssrc emacs emacs19 fileutils find gawk gettext grep gzip hello indent ispell m4 rcs recode sed shellutils tar textutils uudecode wdiff gprof target-groff guile perl apache inet time ash bash bzip2 prms snavigator gnuserv target-gperf"
97
98 # directories to be built in a cross environment only
99 #
100 cross_only="target-libgloss target-newlib target-cygmon target-opcodes target-libstub"
101
102 ## All tools belong in one of the four categories, and are assigned above
103 ## We assign ${configdirs} this way to remove all embedded newlines. This
104 ## is important because configure will choke if they ever get through.
105 ## ${configdirs} is directories we build using the host tools.
106 ## ${target_configdirs} is directories we build using the target tools.
107 #
108 configdirs=`echo ${host_libs} ${host_tools}`
109 target_configdirs=`echo ${target_libs} ${target_tools}`
110
111 ################################################################################
112
113 srctrigger=move-if-change
114 srcname="gnu development package"
115
116 # This gets set non-empty for some net releases of packages.
117 appdirs=""
118
119 # per-host:
120
121 # Work in distributions that contain no compiler tools, like Autoconf.
122 tentative_cc=""
123 if test -d ${srcdir}/config ; then
124 case "${host}" in
125 m68k-hp-hpux*)
126 # Avoid "too much defining" errors from HPUX compiler.
127 tentative_cc="cc -Wp,-H256000"
128 host_makefile_frag="${host_makefile_frag} config/mh-hp300"
129 ;;
130 m68k-apollo-sysv*)
131 tentative_cc="cc -A ansi -A runtype,any -A systype,any -U__STDC__ -DUSG"
132 host_makefile_frag="${host_makefile_frag} config/mh-apollo68"
133 ;;
134 m68k-apollo-bsd*)
135 #None of the Apollo compilers can compile gas or binutils. The preprocessor
136 # chokes on bfd, the compiler won't let you assign integers to enums, and
137 # other problems. Defining CC to gcc is a questionable way to say "don't use
138 # the apollo compiler" (the preferred version of GCC could be called cc,
139 # or whatever), but I'm not sure leaving CC as cc is any better...
140 #CC=cc -A ansi -A runtype,any -A systype,any -U__STDC__ -DNO_STDARG
141 tentative_cc=gcc
142 host_makefile_frag="${host_makefile_frag} config/mh-a68bsd"
143 ;;
144 m88k-dg-dgux*)
145 tentative_cc="gcc -Wall -ansi -D__using_DGUX"
146 host_makefile_frag="${host_makefile_frag} config/mh-dgux"
147 ;;
148 m88k-harris-cxux*)
149 # Under CX/UX, we want to tell the compiler to use ANSI mode.
150 tentative_cc="cc -Xa"
151 host_makefile_frag="${host_makefile_frag} config/mh-cxux"
152 ;;
153 m88k-motorola-sysv*)
154 host_makefile_frag="${host_makefile_frag} config/mh-delta88"
155 ;;
156 mips*-dec-ultrix*)
157 tentative_cc="cc -Wf,-XNg1000"
158 host_makefile_frag="${host_makefile_frag} config/mh-decstation"
159 ;;
160 mips*-nec-sysv4*)
161 # The C compiler on NEC MIPS SVR4 needs bigger tables.
162 tentative_cc="cc -ZXNd=5000 -ZXNg=1000"
163 host_makefile_frag="${host_makefile_frag} config/mh-necv4"
164 ;;
165 mips*-sgi-irix6*)
166 host_makefile_frag="${host_makefile_frag} config/mh-irix6"
167 ;;
168 mips*-sgi-irix5*)
169 host_makefile_frag="${host_makefile_frag} config/mh-irix5"
170 ;;
171 mips*-sgi-irix4*)
172 # Tell compiler to use K&R C. We can't compile under the SGI Ansi
173 # environment. Also bump switch table size so that cp-parse will
174 # compile. Bump string length limit so linker builds.
175 tentative_cc="cc -cckr -Wf,-XNg1500 -Wf,-XNk1000 -Wf,-XNh2000 -Wf,-XNl8192"
176 host_makefile_frag="${host_makefile_frag} config/mh-irix4"
177 ;;
178 mips*-sgi-irix3*)
179 host_makefile_frag="${host_makefile_frag} config/mh-sysv"
180 ;;
181 mips*-*-sysv4*)
182 host_makefile_frag="${host_makefile_frag} config/mh-sysv4"
183 ;;
184 mips*-*-sysv*)
185 # This is for a MIPS running RISC/os 4.52C.
186
187 # This is needed for GDB, but needs to be in the top-level make because
188 # if a library is compiled with the bsd headers and gets linked with the
189 # sysv system libraries all hell can break loose (e.g. a jmp_buf might be
190 # a different size).
191 # ptrace(2) apparently has problems in the BSD environment. No workaround is
192 # known except to select the sysv environment. Could we use /proc instead?
193 # These "sysv environments" and "bsd environments" often end up being a pain.
194 #
195 # This is not part of CFLAGS because perhaps not all C compilers have this
196 # option.
197 tentative_cc="cc -systype sysv"
198 host_makefile_frag="${host_makefile_frag} config/mh-riscos"
199 ;;
200 i370-ibm-opened*)
201 tentative_cc="c89"
202 host_makefile_frag="${host_makefile_frag} config/mh-openedition"
203 ;;
204 i[3456]86-*-sysv5*)
205 host_makefile_frag="${host_makefile_frag} config/mh-sysv5"
206 ;;
207 i[3456]86-*-dgux*)
208 tentative_cc="gcc -Wall -ansi -D__using_DGUX"
209 host_makefile_frag="${host_makefile_frag} config/mh-dgux386"
210 ;;
211 i[3456]86-ncr-sysv4.3*)
212 # The MetaWare compiler will generate a copyright message unless you
213 # turn it off by adding the -Hnocopyr flag.
214 tentative_cc="cc -Hnocopyr"
215 host_makefile_frag="${host_makefile_frag} config/mh-ncrsvr43"
216 ;;
217 i[3456]86-ncr-sysv4*)
218 # for an NCR 3000 (i486/SVR4) system.
219 # The NCR 3000 ships with a MetaWare compiler installed as /bin/cc.
220 # This compiler not only emits obnoxious copyright messages every time
221 # you run it, but it chokes and dies on a whole bunch of GNU source
222 # files. Default to using the AT&T compiler installed in /usr/ccs/ATT/cc.
223 tentative_cc="/usr/ccs/ATT/cc"
224 host_makefile_frag="${host_makefile_frag} config/mh-ncr3000"
225 ;;
226 i[3456]86-*-sco3.2v5*)
227 host_makefile_frag="${host_makefile_frag} config/mh-sysv"
228 ;;
229 i[3456]86-*-sco*)
230 # The native C compiler botches some simple uses of const. Unfortunately,
231 # it doesn't defined anything like "__sco__" for us to test for in ansidecl.h.
232 tentative_cc="cc -Dconst="
233 host_makefile_frag="${host_makefile_frag} config/mh-sco"
234 ;;
235 i[3456]86-*-udk*)
236 host_makefile_frag="${host_makefile_frag} config/mh-sysv5"
237 ;;
238 i[3456]86-*-isc*)
239 host_makefile_frag="${host_makefile_frag} config/mh-sysv"
240 ;;
241 i[3456]86-*-solaris2*)
242 host_makefile_frag="${host_makefile_frag} config/mh-sysv4"
243 ;;
244 i[3456]86-*-aix*)
245 host_makefile_frag="${host_makefile_frag} config/mh-aix386"
246 ;;
247 i[3456]86-*-msdosdjgpp*)
248 host_makefile_frag="${host_makefile_frag} config/mh-djgpp"
249 ;;
250 *-cygwin*)
251 host_makefile_frag="${host_makefile_frag} config/mh-cygwin"
252 ;;
253 *-mingw32*)
254 host_makefile_frag="${host_makefile_frag} config/mh-mingw32"
255 ;;
256 *-interix*)
257 host_makefile_frag="${host_makefile_frag} config/mh-interix"
258 ;;
259 vax-*-ultrix2*)
260 # The old BSD pcc isn't up to compiling parts of gdb so use gcc
261 tentative_cc=gcc
262 ;;
263 *-*-solaris2*)
264 host_makefile_frag="${host_makefile_frag} config/mh-solaris"
265 ;;
266 m68k-sun-sunos*)
267 # Sun's C compiler needs the -J flag to be able to compile cp-parse.c
268 # without overflowing the jump tables (-J says to use a 32 bit table)
269 tentative_cc="cc -J"
270 ;;
271 *-hp-hpux[78]*)
272 tentative_cc="cc -Wp,-H256000"
273 host_makefile_frag="${host_makefile_frag} config/mh-hpux8"
274 ;;
275 *-hp-hpux*)
276 tentative_cc="cc -Wp,-H256000"
277 host_makefile_frag="${host_makefile_frag} config/mh-hpux"
278 ;;
279 *-*-hiux*)
280 tentative_cc="cc -Wp,-H256000"
281 host_makefile_frag="${host_makefile_frag} config/mh-hpux"
282 ;;
283 rs6000-*-lynxos*)
284 # /bin/cc is less than useful for our purposes. Always use GCC
285 tentative_cc="/usr/cygnus/progressive/bin/gcc"
286 host_makefile_frag="${host_makefile_frag} config/mh-lynxrs6k"
287 ;;
288 *-*-lynxos*)
289 # /bin/cc is less than useful for our purposes. Always use GCC
290 tentative_cc="/bin/gcc"
291 ;;
292 *-*-sysv4*)
293 host_makefile_frag="${host_makefile_frag} config/mh-sysv4"
294 ;;
295 *-*-sysv*)
296 host_makefile_frag="${host_makefile_frag} config/mh-sysv"
297 ;;
298 esac
299 fi
300
301 # If we aren't going to be using gcc, see if we can extract a definition
302 # of CC from the fragment.
303 # Actually, use the 'pre-extracted' version above.
304 if test -z "${CC}" && test "${build}" = "${host}" ; then
305 IFS="${IFS= }"; save_ifs="$IFS"; IFS="${IFS}:"
306 found=
307 for dir in $PATH; do
308 test -z "$dir" && dir=.
309 if test -f $dir/gcc; then
310 found=yes
311 break
312 fi
313 done
314 IFS="$save_ifs"
315 if test -z "${found}" && test -n "${tentative_cc}" ; then
316 CC=$tentative_cc
317 fi
318 fi
319
320 # We default to --with-shared on platforms where -fpic is meaningless.
321 # Well, we don't yet, but we will.
322 if false && test "${host}" = "${target}" && test x${enable_shared} = x ; then
323 case "${target}" in
324 alpha*-dec-osf*) enable_shared=yes ;;
325 alpha*-*-linux*) enable_shared=yes ;;
326 mips-sgi-irix5*) enable_shared=yes ;;
327 *) enable_shared=no ;;
328 esac
329 fi
330
331 # hpux11 in 64bit mode has libraries in a weird place. Arrange to find
332 # them automatically.
333 case "${host}" in
334 hppa*64*-*-hpux11*)
335 withoptions="$withoptions -x-libraries=/usr/lib/pa20_64 -x-includes=/usr/X11R6/include"
336 ;;
337 esac
338
339 case "${enable_shared}" in
340 yes) shared=yes ;;
341 no) shared=no ;;
342 "") shared=no ;;
343 *) shared=yes ;;
344 esac
345
346 rm -f mh-frag
347 if test -n "${host_makefile_frag}" ; then
348 for f in ${host_makefile_frag}
349 do
350 cat ${srcdir}/$f >> mh-frag
351 done
352 host_makefile_frag=mh-frag
353 fi
354
355 # per-target:
356
357 case "${target}" in
358 v810*)
359 target_makefile_frag="${target_makefile_frag} config/mt-v810"
360 ;;
361 i[3456]86-*-netware*)
362 target_makefile_frag="${target_makefile_frag} config/mt-netware"
363 ;;
364 powerpc-*-netware*)
365 target_makefile_frag="${target_makefile_frag} config/mt-netware"
366 ;;
367 alpha*-*-linux*)
368 target_makefile_frag="${target_makefile_frag} config/mt-linux"
369 target_makefile_frag="${target_makefile_frag} config/mt-alphaieee"
370 ;;
371 alpha*-*-*)
372 target_makefile_frag="${target_makefile_frag} config/mt-alphaieee"
373 ;;
374 *-*-linux*)
375 target_makefile_frag="${target_makefile_frag} config/mt-linux"
376 ;;
377 *-*-aix4.[3456789]* | *-*-aix[56789].*)
378 target_makefile_frag="${target_makefile_frag} config/mt-aix43"
379 ;;
380 mips*-*-pe | sh*-*-pe | *arm-wince-pe)
381 target_makefile_frag="${target_makefile_frag} config/mt-wince"
382 ;;
383 esac
384
385 # If --enable-target-optspace always use -Os instead of -O2 to build
386 # the target libraries, similarly if it is not specified, use -Os
387 # on selected platforms.
388 case "${enable_target_optspace}:${target}" in
389 yes:*)
390 target_makefile_frag="${target_makefile_frag} config/mt-ospace"
391 ;;
392 :d30v-*)
393 target_makefile_frag="${target_makefile_frag} config/mt-d30v"
394 ;;
395 :m32r-* | :d10v-* | :fr30-*)
396 target_makefile_frag="${target_makefile_frag} config/mt-ospace"
397 ;;
398 no:* | :*)
399 ;;
400 *)
401 echo "*** bad value \"${enable_target_optspace}\" for --enable-target-optspace flag; ignored" 1>&2
402 ;;
403 esac
404
405 skipdirs=
406 gasdir=gas
407 use_gnu_ld=
408 use_gnu_as=
409
410 # some tools are so dependent upon X11 that if we're not building with X,
411 # it's not even worth trying to configure, much less build, that tool.
412
413 case ${with_x} in
414 yes | "") # the default value for this tree is that X11 is available
415 ;;
416 no)
417 skipdirs="${skipdirs} tk libgui"
418 ;;
419 *)
420 echo "*** bad value \"${with_x}\" for -with-x flag; ignored" 1>&2
421 ;;
422 esac
423
424 # Some tools are only suitable for building in a "native" situation.
425 # Those are added when we have a host==target configuration. For cross
426 # toolchains, we add some directories that should only be useful in a
427 # cross-compiler.
428
429 is_cross_compiler=
430
431 if test x"${host}" = x"${target}" ; then
432 # when doing a native toolchain, don't build the targets
433 # that are in the 'cross only' list
434 skipdirs="${skipdirs} ${cross_only}"
435 is_cross_compiler=no
436 else
437 # similarly, don't build the targets in the 'native only'
438 # list when building a cross compiler
439 skipdirs="${skipdirs} ${native_only}"
440 is_cross_compiler=yes
441 fi
442
443 # We always want to use the same name for this directory, so that dejagnu
444 # can reliably find it.
445 target_subdir=${target_alias}
446
447 if test ! -d ${target_subdir} ; then
448 if mkdir ${target_subdir} ; then true
449 else
450 echo "'*** could not make ${PWD=`pwd`}/${target_subdir}" 1>&2
451 exit 1
452 fi
453 fi
454
455 build_subdir=${build_alias}
456
457 if test x"${build_alias}" != x"${host}" ; then
458 if test ! -d ${build_subdir} ; then
459 if mkdir ${build_subdir} ; then true
460 else
461 echo "'*** could not make ${PWD=`pwd`}/${build_subdir}" 1>&2
462 exit 1
463 fi
464 fi
465 fi
466
467 copy_dirs=
468
469 # Handle --with-headers=XXX. The contents of the named directory are
470 # copied to $(tooldir)/sys-include.
471 if test x"${with_headers}" != x ; then
472 if test x${is_cross_compiler} = xno ; then
473 echo 1>&2 '***' --with-headers is only supported when cross compiling
474 exit 1
475 fi
476 case "${exec_prefixoption}" in
477 "") x=${prefix} ;;
478 *) x=${exec_prefix} ;;
479 esac
480 copy_dirs="${copy_dirs} ${with_headers} $x/${target_alias}/sys-include"
481 fi
482
483 # Handle --with-libs=XXX. Multiple directories are permitted. The
484 # contents are copied to $(tooldir)/lib.
485 if test x"${with_libs}" != x ; then
486 if test x${is_cross_compiler} = xno ; then
487 echo 1>&2 '***' --with-libs is only supported when cross compiling
488 exit 1
489 fi
490 # Copy the libraries in reverse order, so that files in the first named
491 # library override files in subsequent libraries.
492 case "${exec_prefixoption}" in
493 "") x=${prefix} ;;
494 *) x=${exec_prefix} ;;
495 esac
496 for l in ${with_libs}; do
497 copy_dirs="$l $x/${target_alias}/lib ${copy_dirs}"
498 done
499 fi
500
501 # If both --with-headers and --with-libs are specified, default to
502 # --without-newlib.
503 if test x"${with_headers}" != x && test x"${with_libs}" != x ; then
504 if test x"${with_newlib}" = x ; then
505 with_newlib=no
506 fi
507 fi
508
509 # Recognize --with-newlib/--without-newlib.
510 if test x${with_newlib} = xno ; then
511 skipdirs="${skipdirs} target-newlib"
512 elif test x${with_newlib} = xyes ; then
513 skipdirs=`echo " ${skipdirs} " | sed -e 's/ target-newlib / /'`
514 fi
515
516 # Default to using --with-stabs for certain targets.
517 if test x${with_stabs} = x ; then
518 case "${target}" in
519 mips*-*-irix6*)
520 ;;
521 mips*-*-* | alpha*-*-osf*)
522 with_stabs=yes;
523 withoptions="${withoptions} --with-stabs"
524 ;;
525 esac
526 fi
527
528 # Handle ${copy_dirs}
529 set fnord ${copy_dirs}
530 shift
531 while test $# != 0 ; do
532 if test -f $2/COPIED && test x"`cat $2/COPIED`" = x"$1" ; then
533 :
534 else
535 echo Copying $1 to $2
536
537 # Use the install script to create the directory and all required
538 # parent directories.
539 if test -d $2 ; then
540 :
541 else
542 echo >config.temp
543 ${srcdir}/install-sh -c -m 644 config.temp $2/COPIED
544 fi
545
546 # Copy the directory, assuming we have tar.
547 # FIXME: Should we use B in the second tar? Not all systems support it.
548 (cd $1; tar -cf - .) | (cd $2; tar -xpf -)
549
550 # It is the responsibility of the user to correctly adjust all
551 # symlinks. If somebody can figure out how to handle them correctly
552 # here, feel free to add the code.
553
554 echo $1 > $2/COPIED
555 fi
556 shift; shift
557 done
558
559 # Configure extra directories which are host specific
560
561 case "${host}" in
562 i[3456]86-*-go32*)
563 configdirs="$configdirs dosrel" ;;
564 i[3456]86-*-mingw32*)
565 configdirs="$configdirs dosrel" ;;
566 *-cygwin*)
567 configdirs="$configdirs libtermcap dosrel" ;;
568 esac
569
570 # Remove more programs from consideration, based on the host or
571 # target this usually means that a port of the program doesn't
572 # exist yet.
573
574 noconfigdirs=""
575
576 case "${host}" in
577 hppa*64*-*-*)
578 noconfigdirs="$noconfigdirs byacc"
579 ;;
580 i[3456]86-*-vsta)
581 noconfigdirs="tcl expect dejagnu make texinfo bison patch flex byacc send-pr gprof uudecode dejagnu diff guile perl apache inet itcl tix db snavigator gnuserv gettext"
582 ;;
583 i[3456]86-*-go32* | i[3456]86-*-msdosdjgpp*)
584 noconfigdirs="tcl tk expect dejagnu send-pr uudecode guile apache inet itcl tix db snavigator gnuserv libffi"
585 ;;
586 i[3456]86-*-mingw32*)
587 # noconfigdirs="tcl tk expect dejagnu make texinfo bison patch flex byacc send-pr uudecode dejagnu diff guile perl apache inet itcl tix db snavigator gnuserv"
588 noconfigdirs="expect dejagnu cvs autoconf automake send-pr rcs guile perl texinfo apache inet libtool"
589 ;;
590 i[3456]86-*-beos*)
591 noconfigdirs="$noconfigdirs tk itcl tix libgui gdb"
592 ;;
593 *-*-cygwin*)
594 noconfigdirs="autoconf automake send-pr rcs guile perl apache inet"
595 ;;
596 *-*-netbsd*)
597 noconfigdirs="rcs"
598 ;;
599 ppc*-*-pe)
600 noconfigdirs="patch diff make tk tcl expect dejagnu cvssrc autoconf automake texinfo bison send-pr gprof rcs guile perl apache inet itcl tix db snavigator gnuserv"
601 ;;
602 powerpc-*-beos*)
603 noconfigdirs="$noconfigdirs tk itcl tix libgui gdb dejagnu readline"
604 ;;
605 esac
606
607 # Save it here so that, even in case of --enable-libgcj, if the Java
608 # front-end isn't enabled, we still get libgcj disabled.
609 libgcj_saved=$libgcj
610 case $enable_libgcj in
611 yes)
612 # If we reset it here, it won't get added to noconfigdirs in the
613 # target-specific build rules, so it will be forcibly enabled
614 # (unless the Java language itself isn't enabled).
615 libgcj=
616 ;;
617 no)
618 # Make sure we get it printed in the list of not supported target libs.
619 noconfigdirs="$noconfigdirs ${libgcj}"
620 ;;
621 esac
622
623 case "${target}" in
624 *-*-chorusos)
625 noconfigdirs="$noconfigdirs target-newlib target-libgloss ${libgcj}"
626 ;;
627 *-*-freebsd[12] | *-*-freebsd[12].* | *-*-freebsd*aout*)
628 noconfigdirs="$noconfigdirs target-newlib target-libgloss ${libgcj}"
629 ;;
630 *-*-netbsd*)
631 # Skip some stuff on all NetBSD configurations.
632 skipdirs="$skipdirs target-newlib target-libiberty target-libgloss"
633
634 # Skip some stuff that's unsupported on some NetBSD configurations.
635 case "${target}" in
636 i*86-*-netbsdelf*) ;;
637 *)
638 noconfigdirs="$noconfigdirs ${libgcj}"
639 ;;
640 esac
641 ;;
642 *-*-netware)
643 noconfigdirs="$noconfigdirs ${libstdcxx_version} target-librx target-newlib target-libiberty target-libgloss ${libgcj}"
644 ;;
645 *-*-rtems*)
646 noconfigdirs="$noconfigdirs target-libgloss ${libgcj}"
647 case ${target} in
648 h8300*-*-* | h8500-*-*)
649 noconfigdirs="$noconfigdirs target-libf2c"
650 ;;
651 *) ;;
652 esac
653 ;;
654 *-*-vxworks*)
655 noconfigdirs="$noconfigdirs target-newlib target-libgloss ${libgcj}"
656 ;;
657 alpha*-dec-osf*)
658 # ld works, but does not support shared libraries. emacs doesn't
659 # work. newlib is not 64 bit ready. I'm not sure about fileutils.
660 # gas doesn't generate exception information.
661 noconfigdirs="$noconfigdirs gas ld emacs fileutils target-newlib target-libgloss"
662 ;;
663 alpha*-*-*vms*)
664 noconfigdirs="$noconfigdirs gdb ld target-newlib target-libgloss ${libgcj}"
665 ;;
666 alpha*-*-linux*)
667 # newlib is not 64 bit ready
668 noconfigdirs="$noconfigdirs target-newlib target-libgloss"
669 # linux has rx in libc
670 skipdirs="$skipdirs target-librx"
671 ;;
672 alpha*-*-freebsd*)
673 noconfigdirs="$noconfigdirs target-newlib target-libgloss"
674 ;;
675 alpha*-*-*)
676 # newlib is not 64 bit ready
677 noconfigdirs="$noconfigdirs target-newlib target-libgloss ${libgcj}"
678 ;;
679 sh-*-linux*)
680 noconfigdirs="$noconfigdirs ${libgcj} target-newlib target-libgloss"
681 # linux has rx in libc
682 skipdirs="$skipdirs target-librx"
683 ;;
684 sh*-*-pe|mips*-*-pe|*arm-wince-pe)
685 noconfigdirs="$noconfigdirs ${libgcj}"
686 noconfigdirs="$noconfigdirs target-examples"
687 noconfigdirs="$noconfigdirs target-libiberty texinfo send-pr"
688 noconfigdirs="$noconfigdirs tcl tix tk itcl libgui sim"
689 noconfigdirs="$noconfigdirs expect dejagnu"
690 # the C++ libraries don't build on top of CE's C libraries
691 noconfigdirs="$noconfigdirs ${libstdcxx_version}"
692 skipdirs="$skipdirs target-newlib"
693 case "${host}" in
694 *-*-cygwin*) ;; # keep gdb and readline
695 *) noconfigdirs="$noconfigdirs gdb readline ${libstdcxx_version}"
696 ;;
697 esac
698 ;;
699 arc-*-*)
700 noconfigdirs="$noconfigdirs target-libgloss ${libgcj}"
701 ;;
702 arm-*-pe*)
703 noconfigdirs="$noconfigdirs target-libgloss ${libgcj}"
704 ;;
705 arm-*-oabi*)
706 noconfigdirs="$noconfigdirs target-libgloss ${libgcj}"
707 ;;
708 thumb-*-coff)
709 noconfigdirs="$noconfigdirs target-libgloss ${libgcj}"
710 ;;
711 thumb-*-elf)
712 noconfigdirs="$noconfigdirs target-libgloss ${libgcj}"
713 ;;
714 thumb-*-oabi)
715 noconfigdirs="$noconfigdirs target-libgloss ${libgcj}"
716 ;;
717 strongarm-*-elf)
718 noconfigdirs="$noconfigdirs ${libgcj}"
719 ;;
720 strongarm-*-coff)
721 noconfigdirs="$noconfigdirs ${libgcj}"
722 ;;
723 xscale-*-elf)
724 noconfigdirs="$noconfigdirs target-libffi target-qthreads"
725 ;;
726 xscale-*-coff)
727 noconfigdirs="$noconfigdirs ${libgcj}"
728 ;;
729 thumb-*-pe)
730 noconfigdirs="$noconfigdirs target-libgloss ${libgcj}"
731 ;;
732 arm-*-riscix*)
733 noconfigdirs="$noconfigdirs ld target-libgloss ${libgcj}"
734 ;;
735 c4x-*-*)
736 noconfigdirs="$noconfigdirs ${libstdcxx_version} target-librx target-libgloss ${libgcj}"
737 ;;
738 c54x*-*-* | tic54x-*-*)
739 noconfigdirs="$noconfigdirs ${libstdcxx_version} target-libgloss ${libgcj} gcc gdb newlib"
740 ;;
741 cris-*-*)
742 noconfigdirs="$noconfigdirs ${libgcj}"
743 ;;
744 d10v-*-*)
745 noconfigdirs="$noconfigdirs target-librx ${libstdcxx_version} target-libgloss ${libgcj}"
746 ;;
747 d30v-*-*)
748 noconfigdirs="$noconfigdirs ${libgcj}"
749 ;;
750 fr30-*-elf*)
751 noconfigdirs="$noconfigdirs ${libgcj}"
752 if test x${is_cross_compiler} != xno ; then
753 target_configdirs="${target_configdirs} target-bsp target-libstub target-cygmon"
754 fi
755 ;;
756 h8300*-*-*)
757 noconfigdirs="$noconfigdirs target-libgloss"
758 ;;
759 h8500-*-*)
760 noconfigdirs="$noconfigdirs ${libstdcxx_version} target-librx target-libgloss ${libgcj} target-libf2c"
761 ;;
762 hppa*64*-*-linux* | parisc*64*-*-linux*)
763 # In this case, it's because the hppa64-linux target is for
764 # the kernel only at this point and has no libc, and thus no
765 # headers, crt*.o, etc., all of which are needed by these.
766 noconfigdirs="$noconfigdirs target-zlib"
767 ;;
768 hppa*-*-*elf* | \
769 parisc*-*-linux* | hppa*-*-linux* | \
770 hppa*-*-lites* | \
771 hppa*64*-*-*)
772 noconfigdirs="$noconfigdirs ${libgcj}"
773 # Do configure ld/binutils/gas for this case.
774 ;;
775 hppa*-*-*)
776 # HP's C compiler doesn't handle Emacs correctly (but on BSD and Mach
777 # cc is gcc, and on any system a user should be able to link cc to
778 # whatever they want. FIXME, emacs emacs19).
779 case "${CC}" in
780 "" | cc*) noconfigdirs="$noconfigdirs emacs emacs19" ;;
781 *) ;;
782 esac
783 # According to Alexandre Oliva <aoliva@redhat.com>, libjava won't
784 # build on HP-UX 10.20.
785 noconfigdirs="$noconfigdirs ld shellutils ${libgcj}"
786 ;;
787 ia64*-*-elf*)
788 # No gdb support yet.
789 noconfigdirs="$noconfigdirs tix readline mmalloc libgui itcl gdb"
790 ;;
791 ia64*-**-hpux*)
792 # No gdb or ld support yet.
793 noconfigdirs="$noconfigdirs tix readline mmalloc libgui itcl gdb ld"
794 ;;
795 i[3456]86-*-coff | i[3456]86-*-elf)
796 noconfigdirs="$noconfigdirs ${libgcj}"
797 if test x${is_cross_compiler} != xno ; then
798 target_configdirs="${target_configdirs} target-libstub target-cygmon"
799 fi
800 ;;
801 i[34567]86-*-freebsd*)
802 noconfigdirs="$noconfigdirs target-newlib target-libgloss"
803 ;;
804 s390*-*-linux*)
805 # The libffi port is not yet in the GCC tree
806 noconfigdirs="$noconfigdirs target-newlib target-libgloss ${libgcj}"
807 # linux has rx in libc
808 skipdirs="$skipdirs target-librx"
809 ;;
810 *-*-linux*)
811 noconfigdirs="$noconfigdirs target-newlib target-libgloss"
812 # linux has rx in libc
813 skipdirs="$skipdirs target-librx"
814 ;;
815 i[3456]86-*-mingw32*)
816 target_configdirs="$target_configdirs target-mingw"
817 noconfigdirs="$noconfigdirs expect target-libgloss ${libgcj}"
818
819 # Can't build gdb for mingw32 if not native.
820 case "${host}" in
821 i[3456]86-*-mingw32) ;; # keep gdb tcl tk expect etc.
822 *) noconfigdirs="$noconfigdirs gdb tcl tk expect itcl tix db snavigator gnuserv"
823 ;;
824 esac
825 ;;
826 *-*-cygwin*)
827 target_configdirs="$target_configdirs target-libtermcap target-winsup"
828 noconfigdirs="$noconfigdirs target-gperf target-libgloss ${libgcj}"
829 # always build newlib.
830 skipdirs=`echo " ${skipdirs} " | sed -e 's/ target-newlib / /'`
831
832 # Can't build gdb for Cygwin if not native.
833 case "${host}" in
834 *-*-cygwin*) ;; # keep gdb tcl tk expect etc.
835 *) noconfigdirs="$noconfigdirs gdb tcl tk expect itcl tix libgui db snavigator gnuserv"
836 ;;
837 esac
838 ;;
839 i[3456]86-*-pe)
840 noconfigdirs="$noconfigdirs ${libstdcxx_version} target-librx target-libgloss ${libgcj}"
841 ;;
842 i[3456]86-*-sco3.2v5*)
843 # The linker does not yet know about weak symbols in COFF,
844 # and is not configured to handle mixed ELF and COFF.
845 noconfigdirs="$noconfigdirs ld target-libgloss ${libgcj}"
846 ;;
847 i[3456]86-*-sco*)
848 noconfigdirs="$noconfigdirs gprof target-libgloss ${libgcj}"
849 ;;
850 i[3456]86-*-solaris2*)
851 noconfigdirs="$noconfigdirs target-libgloss"
852 ;;
853 i[3456]86-*-sysv4*)
854 # The SYSV4 C compiler doesn't handle Emacs correctly
855 case "${CC}" in
856 "" | cc*) noconfigdirs="$noconfigdirs emacs emacs19" ;;
857 *) ;;
858 esac
859 # but that's okay since emacs doesn't work anyway
860 noconfigdirs="$noconfigdirs emacs emacs19 target-libgloss ${libgcj}"
861 ;;
862 i[3456]86-*-beos*)
863 noconfigdirs="$noconfigdirs gdb target-newlib target-libgloss ${libgcj}"
864 ;;
865 m68hc11-*-*|m6811-*-*|m68hc12-*-*|m6812-*-*)
866 noconfigdirs="$noconfigdirs target-libiberty ${libstdcxx_version} ${libgcj}"
867 ;;
868 m68k-*-elf*)
869 noconfigdirs="$noconfigdirs ${libgcj}"
870 if test x${is_cross_compiler} != xno ; then
871 target_configdirs="${target_configdirs} target-bsp target-cygmon"
872 fi
873 ;;
874 m68k-*-coff*)
875 noconfigdirs="$noconfigdirs ${libgcj}"
876 if test x${is_cross_compiler} != xno ; then
877 target_configdirs="${target_configdirs} target-bsp target-cygmon"
878 fi
879 ;;
880 mcore-*-pe*)
881 # The EPOC C++ environment does not support exceptions or rtti,
882 # and so building libstdc++-v3 tends not to always work.
883 noconfigdirs="$noconfigdirs target-libstdc++-v3"
884 ;;
885 mmix-*-*)
886 noconfigdirs="$noconfigdirs ${libgcj}"
887 ;;
888 mn10200-*-*)
889 noconfigdirs="$noconfigdirs ${libgcj}"
890 if test x${is_cross_compiler} != xno ; then
891 target_configdirs="${target_configdirs} target-libstub target-cygmon"
892 fi
893 ;;
894 mn10300-*-*)
895 noconfigdirs="$noconfigdirs ${libgcj}"
896 if test x${is_cross_compiler} != xno ; then
897 target_configdirs="${target_configdirs} target-bsp target-libstub target-cygmon"
898 fi
899 ;;
900 powerpc-*-aix*)
901 # copied from rs6000-*-* entry
902 noconfigdirs="$noconfigdirs gprof cvssrc target-libgloss ${libgcj}"
903 use_gnu_ld=yes
904 ;;
905 powerpc*-*-winnt* | powerpc*-*-pe* | ppc*-*-pe)
906 target_configdirs="$target_configdirs target-winsup"
907 noconfigdirs="$noconfigdirs gdb tcl tk make expect target-libgloss itcl tix db snavigator gnuserv ${libgcj}"
908 # always build newlib.
909 skipdirs=`echo " ${skipdirs} " | sed -e 's/ target-newlib / /'`
910 ;;
911 # This is temporary until we can link against shared libraries
912 powerpcle-*-solaris*)
913 noconfigdirs="$noconfigdirs gdb sim make tcl tk expect itcl tix db snavigator gnuserv ${libgcj}"
914 ;;
915 powerpc-*-beos*)
916 noconfigdirs="$noconfigdirs gdb target-newlib target-libgloss ${libgcj}"
917 ;;
918 powerpc-*-eabi)
919 noconfigdirs="$noconfigdirs ${libgcj}"
920 if test x${is_cross_compiler} != xno ; then
921 target_configdirs="${target_configdirs} target-bsp target-libstub target-cygmon"
922 fi
923 ;;
924 rs6000-*-lynxos*)
925 # The CVS server code doesn't work on the RS/6000
926 noconfigdirs="$noconfigdirs target-newlib gprof cvssrc ${libgcj}"
927 ;;
928 rs6000-*-aix*)
929 noconfigdirs="$noconfigdirs gprof ${libgcj}"
930 use_gnu_ld=yes
931 ;;
932 rs6000-*-*)
933 noconfigdirs="$noconfigdirs gprof ${libgcj}"
934 ;;
935 m68k-apollo-*)
936 noconfigdirs="$noconfigdirs ld binutils gprof target-libgloss ${libgcj}"
937 ;;
938 mips*-*-irix5*)
939 # The GNU linker does not support shared libraries.
940 # emacs is emacs 18, which does not work on Irix 5 (emacs19 does work)
941 noconfigdirs="$noconfigdirs ld gprof emacs target-libgloss ${libgcj}"
942 ;;
943 mips*-*-irix6*)
944 # The GNU assembler does not support IRIX 6.
945 # emacs is emacs 18, which does not work on Irix 5 (emacs19 does work)
946 # Linking libjava exceeds command-line length limits on at least
947 # IRIX 6.2, but not on IRIX 6.5.
948 # Also, boehm-gc won't build on IRIX 6.5, according to Jeffrey Oldham
949 # <oldham@codesourcery.com>
950 noconfigdirs="$noconfigdirs gas gprof emacs target-libgloss ${libgcj}"
951 ;;
952 mips*-dec-bsd*)
953 noconfigdirs="$noconfigdirs gprof target-libgloss ${libgcj}"
954 ;;
955 mips*-*-bsd*)
956 noconfigdirs="$noconfigdirs gprof target-libgloss ${libgcj}"
957 ;;
958 mipstx39-*-*)
959 noconfigdirs="$noconfigdirs gprof ${libgcj}" # same as generic mips
960 target_configdirs="${target_configdirs} target-bsp target-libstub target-cygmon"
961 ;;
962 mips*-*-linux*)
963 noconfigdirs="$noconfigdirs target-libffi"
964 ;;
965 mips*-*-*)
966 noconfigdirs="$noconfigdirs gprof ${libgcj}"
967 ;;
968 romp-*-*)
969 noconfigdirs="$noconfigdirs bfd binutils ld gas opcodes target-libgloss ${libgcj}"
970 ;;
971 sh-*-*)
972 case "${host}" in
973 i[3456]86-*-vsta) ;; # don't add gprof back in
974 i[3456]86-*-go32*) ;; # don't add gprof back in
975 i[3456]86-*-msdosdjgpp*) ;; # don't add gprof back in
976 *) skipdirs=`echo " ${skipdirs} " | sed -e 's/ gprof / /'` ;;
977 esac
978 noconfigdirs="$noconfigdirs target-libgloss ${libgcj}"
979 ;;
980 sh64-*-*)
981 noconfigdirs="$noconfigdirs target-libgloss ${libgcj}"
982 ;;
983 sparc-*-elf*)
984 if test x${is_cross_compiler} != xno ; then
985 target_configdirs="${target_configdirs} target-libstub target-cygmon"
986 fi
987 noconfigdirs="$noconfigdirs ${libgcj}"
988 ;;
989 sparc64-*-elf*)
990 if test x${is_cross_compiler} != xno ; then
991 target_configdirs="${target_configdirs} target-libstub target-cygmon"
992 fi
993 noconfigdirs="$noconfigdirs ${libgcj}"
994 ;;
995 sparclite-*-*)
996 if test x${is_cross_compiler} != xno ; then
997 target_configdirs="${target_configdirs} target-bsp target-libstub target-cygmon"
998 fi
999 noconfigdirs="$noconfigdirs ${libgcj}"
1000 ;;
1001 sparc-*-sunos4*)
1002 noconfigdirs="$noconfigdirs ${libgcj}"
1003 if test x${is_cross_compiler} != xno ; then
1004 noconfigdirs="$noconfigdirs gdb gdbtest target-newlib target-libgloss"
1005 else
1006 use_gnu_ld=no
1007 fi
1008 ;;
1009 sparc-*-solaris*)
1010 ;;
1011 v810-*-*)
1012 noconfigdirs="$noconfigdirs bfd binutils gas gcc gdb ld ${libstdcxx_version} opcodes target-libgloss ${libgcj}"
1013 ;;
1014 v850-*-*)
1015 noconfigdirs="$noconfigdirs target-libgloss ${libgcj}"
1016 ;;
1017 v850e-*-*)
1018 noconfigdirs="$noconfigdirs target-libgloss ${libgcj}"
1019 ;;
1020 v850ea-*-*)
1021 noconfigdirs="$noconfigdirs target-libgloss ${libgcj}"
1022 ;;
1023 vax-*-vms)
1024 noconfigdirs="$noconfigdirs bfd binutils gdb ld target-newlib opcodes target-libgloss ${libgcj}"
1025 ;;
1026 vax-*-*)
1027 noconfigdirs="$noconfigdirs target-newlib target-libgloss ${libgcj}"
1028 ;;
1029 *-*-lynxos*)
1030 noconfigdirs="$noconfigdirs target-newlib target-libgloss ${libgcj}"
1031 ;;
1032 *-*-macos* | \
1033 *-*-mpw*)
1034 # Macs want a resource compiler.
1035 configdirs="$configdirs grez"
1036 noconfigdirs="$noconfigdirs ${libgcj}"
1037 ;;
1038 *-*-*)
1039 noconfigdirs="$noconfigdirs ${libgcj}"
1040 ;;
1041 esac
1042
1043 # If we aren't building newlib, then don't build libgloss, since libgloss
1044 # depends upon some newlib header files.
1045 case "${noconfigdirs}" in
1046 *target-libgloss*) ;;
1047 *target-newlib*) noconfigdirs="$noconfigdirs target-libgloss" ;;
1048 esac
1049
1050 # Make sure we don't let GNU ld be added if we didn't want it.
1051 if test x$with_gnu_ld = xno ; then
1052 use_gnu_ld=no
1053 noconfigdirs="$noconfigdirs ld"
1054 fi
1055
1056 # Make sure we don't let GNU as be added if we didn't want it.
1057 if test x$with_gnu_as = xno ; then
1058 use_gnu_as=no
1059 noconfigdirs="$noconfigdirs gas"
1060 fi
1061
1062 # Figure out what language subdirectories are present.
1063 # Look if the user specified --enable-languages="..."; if not, use
1064 # the environment variable $LANGUAGES if defined. $LANGUAGES might
1065 # go away some day.
1066 # NB: embedded tabs in this IF block -- do not untabify
1067 if test x"${enable_languages+set}" != xset; then
1068 if test x"${LANGUAGES+set}" = xset; then
1069 enable_languages="${LANGUAGES}"
1070 echo configure.in: warning: setting LANGUAGES is deprecated, use --enable-languages instead 1>&2
1071 else
1072 enable_languages=all
1073 fi
1074 else
1075 if test x"${enable_languages}" = x ||
1076 test x"${enable_languages}" = xyes;
1077 then
1078 echo configure.in: --enable-languages needs at least one language argument 1>&2
1079 exit 1
1080 fi
1081 fi
1082 enable_languages=`echo "${enable_languages}" | sed -e 's/[ ,][ ,]*/,/g' -e 's/,$//'`
1083
1084 # First scan to see if an enabled language requires some other language.
1085 # We assume that a given config-lang.in will list all the language
1086 # front ends it requires, even if some are required indirectly.
1087 for lang in ${srcdir}/gcc/*/config-lang.in ..
1088 do
1089 case $lang in
1090 ..)
1091 ;;
1092 # The odd quoting in the next line works around
1093 # an apparent bug in bash 1.12 on linux.
1094 ${srcdir}/gcc/[*]/config-lang.in)
1095 ;;
1096 *)
1097 lang_alias=`sed -n -e 's,^language=['"'"'"'"]\(.*\)["'"'"'"'].*$,\1,p' -e 's,^language=\([^ ]*\).*$,\1,p' $lang`
1098 this_lang_requires=`sed -n -e 's,^lang_requires=['"'"'"'"]\(.*\)["'"'"'"'].*$,\1,p' -e 's,^lang_requires=\([^ ]*\).*$,\1,p' $lang`
1099 for other in $this_lang_requires
1100 do
1101 case ,${enable_languages}, in
1102 *,$other,*)
1103 ;;
1104 *,all,*)
1105 ;;
1106 *,$lang_alias,*)
1107 echo " \`$other' language required by \`$lang_alias'; enabling" 1>&2
1108 enable_languages="$enable_languages,$other"
1109 ;;
1110 esac
1111 done
1112 ;;
1113 esac
1114 done
1115
1116 subdirs=
1117 for lang in ${srcdir}/gcc/*/config-lang.in ..
1118 do
1119 case $lang in
1120 ..) ;;
1121 # The odd quoting in the next line works around
1122 # an apparent bug in bash 1.12 on linux.
1123 ${srcdir}/gcc/[*]/config-lang.in) ;;
1124 *)
1125 lang_alias=`sed -n -e 's,^language=['"'"'"'"]\(.*\)["'"'"'"'].*$,\1,p' -e 's,^language=\([^ ]*\).*$,\1,p' $lang`
1126 this_lang_libs=`sed -n -e 's,^target_libs=['"'"'"'"]\(.*\)["'"'"'"'].*$,\1,p' -e 's,^target_libs=\([^ ]*\).*$,\1,p' $lang`
1127 this_lang_dirs=`sed -n -e 's,^lang_dirs=['"'"'"'"]\(.*\)["'"'"'"'].*$,\1,p' -e 's,^lang_dirs=\([^ ]*\).*$,\1,p' $lang`
1128 build_by_default=`sed -n -e 's,^build_by_default=['"'"'"'"]\(.*\)["'"'"'"'].*$,\1,p' -e 's,^build_by_default=\([^ ]*\).*$,\1,p' $lang`
1129 if test "x$lang_alias" = x
1130 then
1131 echo "$lang doesn't set \$language." 1>&2
1132 exit 1
1133 fi
1134 case ${build_by_default},${enable_languages}, in
1135 *,$lang_alias,*) add_this_lang=yes ;;
1136 no,*) add_this_lang=no ;;
1137 *,all,*) add_this_lang=yes ;;
1138 *) add_this_lang=no ;;
1139 esac
1140 if test x"${add_this_lang}" = xyes; then
1141 eval target_libs='"$target_libs "'\"$this_lang_libs\"
1142 else
1143 eval noconfigdirs='"$noconfigdirs "'\"$this_lang_libs $this_lang_dirs\"
1144 fi
1145 ;;
1146 esac
1147 done
1148
1149 # Remove the entries in $skipdirs and $noconfigdirs from $configdirs and
1150 # $target_configdirs.
1151 # If we have the source for $noconfigdirs entries, add them to $notsupp.
1152
1153 notsupp=""
1154 for dir in . $skipdirs $noconfigdirs ; do
1155 dirname=`echo $dir | sed -e s/target-//g`
1156 if test $dir != . && echo " ${configdirs} " | grep " ${dir} " >/dev/null 2>&1; then
1157 configdirs=`echo " ${configdirs} " | sed -e "s/ ${dir} / /"`
1158 if test -r $srcdir/$dirname/configure \
1159 || test -r $srcdir/$dirname/configure.in ; then
1160 if echo " ${skipdirs} " | grep " ${dir} " >/dev/null 2>&1; then
1161 true
1162 else
1163 notsupp="$notsupp $dir"
1164 fi
1165 fi
1166 fi
1167 if test $dir != . && echo " ${target_configdirs} " | grep " ${dir} " >/dev/null 2>&1; then
1168 target_configdirs=`echo " ${target_configdirs} " | sed -e "s/ ${dir} / /"`
1169 if test -r $srcdir/$dirname/configure \
1170 || test -r $srcdir/$dirname/configure.in ; then
1171 if echo " ${skipdirs} " | grep " ${dir} " >/dev/null 2>&1; then
1172 true
1173 else
1174 notsupp="$notsupp $dir"
1175 fi
1176 fi
1177 fi
1178 done
1179
1180 # Sometimes the tools are distributed with libiberty but with no other
1181 # libraries. In that case, we don't want to build target-libiberty.
1182 if test -n "${target_configdirs}" ; then
1183 others=
1184 for i in `echo ${target_configdirs} | sed -e s/target-//g` ; do
1185 if test "$i" != "libiberty" ; then
1186 if test -r $srcdir/$i/configure || test -r $srcdir/$i/configure.in ; then
1187 others=yes;
1188 break;
1189 fi
1190 fi
1191 done
1192 if test -z "${others}" ; then
1193 target_configdirs=
1194 fi
1195 fi
1196
1197 # Deconfigure all subdirectories, in case we are changing the
1198 # configuration from one where a subdirectory is supported to one where it
1199 # is not.
1200 if test -z "${norecursion}" && test -n "${configdirs}" ; then
1201 for i in `echo ${configdirs} | sed -e s/target-//g` ; do
1202 rm -f $i/Makefile
1203 done
1204 fi
1205 if test -z "${norecursion}" && test -n "${target_configdirs}" ; then
1206 for i in `echo ${target_configdirs} | sed -e s/target-//g` ; do
1207 rm -f ${target_subdir}/$i/Makefile
1208 done
1209 fi
1210
1211 # Quietly strip out all directories which aren't configurable in this tree.
1212 # This relies on all configurable subdirectories being autoconfiscated, which
1213 # is now the case.
1214 configdirs_all="$configdirs"
1215 configdirs=
1216 for i in ${configdirs_all} ; do
1217 if test -f ${srcdir}/$i/configure ; then
1218 configdirs="${configdirs} $i"
1219 fi
1220 done
1221 target_configdirs_all="$target_configdirs"
1222 target_configdirs=
1223 for i in ${target_configdirs_all} ; do
1224 j=`echo $i | sed -e s/target-//g`
1225 if test -f ${srcdir}/$j/configure ; then
1226 target_configdirs="${target_configdirs} $i"
1227 fi
1228 done
1229
1230 # Produce a warning message for the subdirs we can't configure.
1231 # This isn't especially interesting in the Cygnus tree, but in the individual
1232 # FSF releases, it's important to let people know when their machine isn't
1233 # supported by the one or two programs in a package.
1234
1235 if test -n "${notsupp}" && test -z "${norecursion}" ; then
1236 # If $appdirs is non-empty, at least one of those directories must still
1237 # be configured, or we error out. (E.g., if the gas release supports a
1238 # specified target in some subdirs but not the gas subdir, we shouldn't
1239 # pretend that all is well.)
1240 if test -n "$appdirs" ; then
1241 for dir in $appdirs ; do
1242 if test -r $dir/Makefile.in ; then
1243 if echo " ${configdirs} " | grep " ${dir} " >/dev/null 2>&1; then
1244 appdirs=""
1245 break
1246 fi
1247 if echo " ${target_configdirs} " | grep " ${dir} " >/dev/null 2>&1; then
1248 appdirs=""
1249 break
1250 fi
1251 fi
1252 done
1253 if test -n "$appdirs" ; then
1254 echo "*** This configuration is not supported by this package." 1>&2
1255 exit 1
1256 fi
1257 fi
1258 # Okay, some application will build, or we don't care to check. Still
1259 # notify of subdirs not getting built.
1260 echo "*** This configuration is not supported in the following subdirectories:" 1>&2
1261 echo " ${notsupp}" 1>&2
1262 echo " (Any other directories should still work fine.)" 1>&2
1263 fi
1264
1265 # Set with_gnu_as and with_gnu_ld as appropriate.
1266 #
1267 # This is done by determining whether or not the appropriate directory
1268 # is available, and by checking whether or not specific configurations
1269 # have requested that this magic not happen.
1270 #
1271 # The command line options always override the explicit settings in
1272 # configure.in, and the settings in configure.in override this magic.
1273 #
1274 # If the default for a toolchain is to use GNU as and ld, and you don't
1275 # want to do that, then you should use the --without-gnu-as and
1276 # --without-gnu-ld options for the configure script.
1277
1278 if test x${use_gnu_as} = x ; then
1279 if test x${with_gnu_as} != xno && echo " ${configdirs} " | grep " ${gasdir} " > /dev/null 2>&1 && test -d ${srcdir}/${gasdir} ; then
1280 with_gnu_as=yes
1281 withoptions="$withoptions --with-gnu-as"
1282 fi
1283 fi
1284
1285 if test x${use_gnu_ld} = x ; then
1286 if test x${with_gnu_ld} != xno && echo " ${configdirs} " | grep " ld " > /dev/null 2>&1 && test -d ${srcdir}/ld ; then
1287 with_gnu_ld=yes
1288 withoptions="$withoptions --with-gnu-ld"
1289 fi
1290 fi
1291
1292 # If using newlib, add --with-newlib to the withoptions so that gcc/configure
1293 # can detect this case.
1294
1295 if test x${with_newlib} != xno && echo " ${target_configdirs} " | grep " target-newlib " > /dev/null 2>&1 && test -d ${srcdir}/newlib ; then
1296 with_newlib=yes
1297 withoptions="$withoptions --with-newlib"
1298 fi
1299
1300 rm -f mt-frag
1301 if test -n "${target_makefile_frag}" ; then
1302 for f in ${target_makefile_frag}
1303 do
1304 cat ${srcdir}/$f >> mt-frag
1305 done
1306 target_makefile_frag=mt-frag
1307 fi
1308
1309 # post-target:
1310
1311 # Make sure that the compiler is able to generate an executable. If it
1312 # can't, we are probably in trouble. We don't care whether we can run the
1313 # executable--we might be using a cross compiler--we only care whether it
1314 # can be created. At this point the main configure script has set CC.
1315 we_are_ok=no
1316 echo "int main () { return 0; }" > conftest.c
1317 ${CC} -o conftest ${CFLAGS} ${CPPFLAGS} ${LDFLAGS} conftest.c
1318 if test $? = 0 ; then
1319 if test -s conftest || test -s conftest.exe ; then
1320 we_are_ok=yes
1321 fi
1322 fi
1323 case $we_are_ok in
1324 no)
1325 echo 1>&2 "*** The command '${CC} -o conftest ${CFLAGS} ${CPPFLAGS} ${LDFLAGS} conftest.c' failed."
1326 echo 1>&2 "*** You must set the environment variable CC to a working compiler."
1327 rm -f conftest*
1328 exit 1
1329 ;;
1330 esac
1331 rm -f conftest*
1332
1333 # The Solaris /usr/ucb/cc compiler does not appear to work.
1334 case "${host}" in
1335 sparc-sun-solaris2*)
1336 CCBASE="`echo ${CC-cc} | sed 's/ .*$//'`"
1337 if test "`type $CCBASE | sed 's/^[^/]*//'`" = "/usr/ucb/cc" ; then
1338 could_use=
1339 test -d /opt/SUNWspro/bin && could_use="/opt/SUNWspro/bin"
1340 if test -d /opt/cygnus/bin ; then
1341 if test "$could_use" = "" ; then
1342 could_use="/opt/cygnus/bin"
1343 else
1344 could_use="$could_use or /opt/cygnus/bin"
1345 fi
1346 fi
1347 if test "$could_use" = "" ; then
1348 echo "Warning: compilation may fail because you're using"
1349 echo "/usr/ucb/cc. You should change your PATH or CC "
1350 echo "variable and rerun configure."
1351 else
1352 echo "Warning: compilation may fail because you're using"
1353 echo "/usr/ucb/cc, when you should use the C compiler from"
1354 echo "$could_use. You should change your"
1355 echo "PATH or CC variable and rerun configure."
1356 fi
1357 fi
1358 ;;
1359 esac
1360
1361 # If we're building libgcj and we're using the Solaris 2.8 linker,
1362 # then we check for a known problem.
1363 if test "x${libgcj}" = x && test "${with_gnu_ld}" != yes \
1364 && test "${is_cross_compiler}" = no; then
1365
1366 case "${host}" in
1367 sparc-*-solaris2.8)
1368 if test "$libdir" = '${exec_prefix}/lib';then
1369 if test "$exec_prefix" = '$(prefix)'; then
1370 tlibdir="$prefix/lib"
1371 else
1372 tlibdir="$exec_prefix/lib"
1373 fi
1374 else
1375 tlibdir="$libdir"
1376 fi
1377 if test -f $tlibdir/libgcj.la; then
1378 echo "*** You've already installed libgcj in $tlibdir." 1>&2
1379 echo " This causes problems when rebuilding libgcj with the Solaris 2.8 linker." 1>&2
1380 echo " Either disable the libgcj build, or remove the" 1>&2
1381 echo " already-installed libgcj files." 1>&2
1382 exit 1
1383 fi
1384 ;;
1385 esac
1386 fi
1387
1388 # If --enable-shared was set, we must set LD_LIBRARY_PATH so that the
1389 # binutils tools will find libbfd.so.
1390 if test "${shared}" = "yes" ; then
1391 sed -e 's/^SET_LIB_PATH[ ]*=.*$/SET_LIB_PATH = $(REALLY_SET_LIB_PATH)/' \
1392 Makefile > Makefile.tem
1393 rm -f Makefile
1394 mv -f Makefile.tem Makefile
1395
1396 case "${host}" in
1397 *-*-hpux*)
1398 sed -e 's/^RPATH_ENVVAR[ ]*=.*$/RPATH_ENVVAR = SHLIB_PATH/' \
1399 Makefile > Makefile.tem
1400 rm -f Makefile
1401 mv -f Makefile.tem Makefile
1402 ;;
1403 esac
1404 fi
1405
1406 # Record target_configdirs and the configure arguments for target and
1407 # build configuration in Makefile.
1408 target_configdirs=`echo "${target_configdirs}" | sed -e 's/target-//g'`
1409 targargs=`echo "${arguments}" | \
1410 sed -e 's/--no[^ ]*//' \
1411 -e 's/--cache[a-z-]*=[^ ]*//' \
1412 -e 's/--ho[a-z-]*=[^ ]*//' \
1413 -e 's/--bu[a-z-]*=[^ ]*//' \
1414 -e 's/--ta[a-z-]*=[^ ]*//'`
1415
1416 # For the build-side libraries, we just need to pretend we're native,
1417 # and not use the same cache file. Multilibs are neither needed nor
1418 # desired.
1419 buildargs="--cache-file=../config.cache --build=${build_alias} --host=${build_alias} ${targargs}"
1420
1421 # Passing a --with-cross-host argument lets the target libraries know
1422 # whether they are being built with a cross-compiler or being built
1423 # native. However, it would be better to use other mechanisms to make the
1424 # sorts of decisions they want to make on this basis. Please consider
1425 # this option to be deprecated. FIXME.
1426 if test x${is_cross_compiler} = xyes ; then
1427 targargs="--with-cross-host=${host_alias} ${targargs}"
1428 fi
1429
1430 # Default to --enable-multilib.
1431 if test x${enable_multilib} = x ; then
1432 targargs="--enable-multilib ${targargs}"
1433 fi
1434
1435 # Pass --with-newlib if appropriate. Note that target_configdirs has
1436 # changed from the earlier setting of with_newlib.
1437 if test x${with_newlib} != xno && echo " ${target_configdirs} " | grep " newlib " > /dev/null 2>&1 && test -d ${srcdir}/newlib ; then
1438 targargs="--with-newlib ${targargs}"
1439 fi
1440
1441 # Pass the appropriate --host, --build, and --cache-file arguments.
1442 targargs="--cache-file=../config.cache --host=${target_alias} --build=${build_alias} ${targargs}"
1443
1444 # provide a proper gxx_include_dir.
1445 # Note, if you change the default, make sure to fix both here and in
1446 # the gcc and libstdc++-v3 subdirectories.
1447 # Check whether --with-gxx-include-dir or --without-gxx-include-dir was given.
1448 gxx_include_dir=
1449 if test -n "${with_gxx_include_dir}"; then
1450 case "${with_gxx_include_dir}" in
1451 yes )
1452 echo "configure.in: error: bad value ${withval} given for g++ include directory" 1>&2
1453 exit 1
1454 ;;
1455 no )
1456 ;;
1457 * )
1458 gxx_include_dir=${with_gxx_include_dir}
1459 ;;
1460 esac
1461 fi
1462 if test x${gxx_include_dir} = x; then
1463 if test x${enable_version_specific_runtime_libs} = xyes; then
1464 gxx_include_dir='${libsubdir}/include/g++'
1465 else
1466 . ${topsrcdir}/config.if
1467 gxx_include_dir='${prefix}/include/${libstdcxx_incdir}'
1468 fi
1469 else
1470 gxx_include_dir=${gxx_include_dir}
1471 fi
1472
1473 FLAGS_FOR_TARGET=
1474 case " $skipdirs " in
1475 *" target-newlib "*) ;;
1476 *)
1477 case " $target_configdirs " in
1478 *" newlib "*)
1479 case " $targargs " in
1480 *" --with-newlib "*)
1481 case "$target" in
1482 *-cygwin*)
1483 FLAGS_FOR_TARGET=$FLAGS_FOR_TARGET' -L$$r/$(TARGET_SUBDIR)/winsup -L$$r/$(TARGET_SUBDIR)/winsup/cygwin -L$$r/$(TARGET_SUBDIR)/winsup/w32api/lib -isystem $$s/winsup/include -isystem $$s/winsup/cygwin/include -isystem $$s/winsup/w32api/include -isystem $$s/newlib/libc/sys/cygwin -isystem $$s/newlib/libc/sys/cygwin32' ;;
1484 esac
1485
1486 # If we're not building GCC, don't discard standard headers.
1487 if test -d ${topsrcdir}/gcc; then
1488 FLAGS_FOR_TARGET=$FLAGS_FOR_TARGET' -nostdinc'
1489
1490 if test "${build}" != "${host}"; then
1491 # On Canadian crosses, CC_FOR_TARGET will have already been set
1492 # by `configure', so we won't have an opportunity to add -Bgcc/
1493 # to it. This is right: we don't want to search that directory
1494 # for binaries, but we want the header files in there, so add
1495 # them explicitly.
1496 FLAGS_FOR_TARGET=$FLAGS_FOR_TARGET' -isystem $$r/gcc/include'
1497
1498 # Someone might think of using the pre-installed headers on
1499 # Canadian crosses, in case the installed compiler is not fully
1500 # compatible with the compiler being built. In this case, it
1501 # would be better to flag an error than risking having
1502 # incompatible object files being constructed. We can't
1503 # guarantee that an error will be flagged, but let's hope the
1504 # compiler will do it, when presented with incompatible header
1505 # files.
1506 fi
1507 fi
1508
1509 case "${target}-${is_cross_compiler}" in
1510 i[3456]86-pc-linux*-no)
1511 # Here host == target, so we don't need to build gcc,
1512 # so we don't want to discard standard headers.
1513 FLAGS_FOR_TARGET=`echo " $FLAGS_FOR_TARGET " | sed -e 's/ -nostdinc / /'`
1514 FLAGS_FOR_TARGET=$FLAGS_FOR_TARGET' -B$$r/$(TARGET_SUBDIR)/newlib/'
1515 ;;
1516 *)
1517 # If we're building newlib, use its generic headers last, but search
1518 # for any libc-related directories first (so make it the last -B
1519 # switch).
1520 FLAGS_FOR_TARGET=$FLAGS_FOR_TARGET' -B$$r/$(TARGET_SUBDIR)/newlib/ -isystem $$r/$(TARGET_SUBDIR)/newlib/targ-include -isystem $$s/newlib/libc/include'
1521 ;;
1522 esac
1523 ;;
1524 esac
1525 ;;
1526 esac
1527 ;;
1528 esac
1529
1530 # On Canadian crosses, we'll be searching the right directories for
1531 # the previously-installed cross compiler, so don't bother to add
1532 # flags for directories within the install tree of the compiler
1533 # being built; programs in there won't even run.
1534 if test "${build}" = "${host}" && test -d ${topsrcdir}/gcc; then
1535 # Search for pre-installed headers if nothing else fits.
1536 FLAGS_FOR_TARGET=$FLAGS_FOR_TARGET' -B$(build_tooldir)/bin/ -B$(build_tooldir)/lib/ -isystem $(build_tooldir)/include'
1537 fi
1538
1539 if test "x${use_gnu_ld}" = x && test "x${with_gnu_ld}" != xno &&
1540 echo " ${configdirs} " | grep " ld " > /dev/null &&
1541 test -d ${srcdir}/ld; then
1542 # Arrange for us to find uninstalled linker scripts.
1543 FLAGS_FOR_TARGET=$FLAGS_FOR_TARGET' -L$$r/ld'
1544 fi
1545
1546 if test "x${CC_FOR_TARGET+set}" = xset; then
1547 :
1548 elif test -d ${topsrcdir}/gcc; then
1549 CC_FOR_TARGET='$$r/gcc/xgcc -B$$r/gcc/'
1550 elif test "$host" = "$target"; then
1551 CC_FOR_TARGET='$(CC)'
1552 else
1553 CC_FOR_TARGET=`echo gcc | sed -e 's/x/x/' ${program_transform_name}`
1554 fi
1555 # On Canadian crosses, configure reads CC_FOR_TARGET from Makefile,
1556 # if Makefile exists. Prevent $(FLAGS_FOR_TARGET) from being duplicated.
1557 case $CC_FOR_TARGET in
1558 *' $(FLAGS_FOR_TARGET)') ;;
1559 *) CC_FOR_TARGET=$CC_FOR_TARGET' $(FLAGS_FOR_TARGET)' ;;
1560 esac
1561
1562 if test "x${GCJ_FOR_TARGET+set}" = xset; then
1563 :
1564 elif test -d ${topsrcdir}/gcc; then
1565 GCJ_FOR_TARGET='$$r/gcc/gcj -B$$r/gcc/'
1566 elif test "$host" = "$target"; then
1567 GCJ_FOR_TARGET='gcj'
1568 else
1569 GCJ_FOR_TARGET=`echo gcj | sed -e 's/x/x/' ${program_transform_name}`
1570 fi
1571 case $GCJ_FOR_TARGET in
1572 *' $(FLAGS_FOR_TARGET)') ;;
1573 *) GCJ_FOR_TARGET=$GCJ_FOR_TARGET' $(FLAGS_FOR_TARGET)' ;;
1574 esac
1575
1576 if test "x${CXX_FOR_TARGET+set}" = xset; then
1577 :
1578 elif test -d ${topsrcdir}/gcc; then
1579 # We add -shared-libgcc to CXX_FOR_TARGET whenever we use xgcc instead
1580 # of g++ for linking C++ or Java, because g++ has -shared-libgcc by
1581 # default whereas gcc does not.
1582 CXX_FOR_TARGET='$$r/gcc/`case $$dir in libstdc++-v3 | libjava) echo xgcc -shared-libgcc ;; *) echo g++ ;; esac` -B$$r/gcc/ -nostdinc++ '$libstdcxx_flags
1583 elif test "$host" = "$target"; then
1584 CXX_FOR_TARGET='$(CXX)'
1585 else
1586 CXX_FOR_TARGET=`echo c++ | sed -e 's/x/x/' ${program_transform_name}`
1587 fi
1588 case $CXX_FOR_TARGET in
1589 *' $(FLAGS_FOR_TARGET)') ;;
1590 *) CXX_FOR_TARGET=$CXX_FOR_TARGET' $(FLAGS_FOR_TARGET)' ;;
1591 esac
1592 qCXX_FOR_TARGET=`echo "$CXX_FOR_TARGET" | sed 's,[&%],\\\&,g'`
1593
1594 # We want to defer the evaluation of `cmd`s and shell variables in
1595 # CXX_FOR_TARGET when recursing in the top-level Makefile, such as for
1596 # bootstrap. We'll enclose CXX_FOR_TARGET_FOR_RECURSIVE_MAKE in single
1597 # quotes, but we still have to duplicate `$'s so that shell variables
1598 # can be expanded by the nested make as shell variables, not as make
1599 # macros.
1600 qqCXX_FOR_TARGET=`echo "$qCXX_FOR_TARGET" | sed -e 's,[$][$],$$$$,g'`
1601
1602 sedtemp=sed.$$
1603 cat >$sedtemp <<EOF
1604 s:^TARGET_CONFIGDIRS[ ]*=.*$:TARGET_CONFIGDIRS = ${target_configdirs}:
1605 s%^TARGET_CONFIGARGS[ ]*=.*$%TARGET_CONFIGARGS = ${targargs}%
1606 s%^FLAGS_FOR_TARGET[ ]*=.*$%FLAGS_FOR_TARGET = ${FLAGS_FOR_TARGET}%
1607 s%^CC_FOR_TARGET[ ]*=.*$%CC_FOR_TARGET = ${CC_FOR_TARGET}%
1608 s%^GCJ_FOR_TARGET[ ]*=.*$%GCJ_FOR_TARGET = ${GCJ_FOR_TARGET}%
1609 s%^CXX_FOR_TARGET[ ]*=.*$%CXX_FOR_TARGET = ${qCXX_FOR_TARGET}%
1610 s%^CXX_FOR_TARGET_FOR_RECURSIVE_MAKE[ ]*=.*$%CXX_FOR_TARGET_FOR_RECURSIVE_MAKE = ${qqCXX_FOR_TARGET}%
1611 s%^TARGET_SUBDIR[ ]*=.*$%TARGET_SUBDIR = ${target_subdir}%
1612 s%^BUILD_SUBDIR[ ]*=.*$%BUILD_SUBDIR = ${build_subdir}%
1613 s%^BUILD_CONFIGARGS[ ]*=.*$%BUILD_CONFIGARGS = ${buildargs}%
1614 s%^gxx_include_dir[ ]*=.*$%gxx_include_dir=${gxx_include_dir}%
1615 EOF
1616 sed -f $sedtemp Makefile > Makefile.tem
1617 rm -f Makefile $sedtemp
1618 mv -f Makefile.tem Makefile
1619
1620 #
1621 # Local Variables:
1622 # fill-column: 131
1623 # End:
1624 #